<?php

/**
 * inf_certif_mensual actions.
 *
 * @package    nomina
 * @subpackage inf_certif_mensual
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_certif_mensualActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_doc, concepto';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select
tab0.*,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO

from(
select tab1.*, tab2.codigo||' - '||tab2.descripcion as concepto, tab3.nombre_apellido,
per.id_anhos, per.id_meses

from no_certi_retefuente tab1

left join no_concep_nomina tab2 ON tab2.id_concep_nomina = tab1.id_concep_nomina
left join no_datos_funcionario_v tab3 on tab3.id_tipo_doc = tab1.id_tipo_doc and tab3.num_doc = tab1.num_doc
left join no_periodo per on per.id_periodo = tab1.id_periodo

)tab0

where tab0.id_anhos || lpad(tab0.id_meses, 2, '0')  <= (select periodo.id_anhos || lpad(periodo.id_meses, 2, '0') 
    from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro)
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select
tab0.*,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO

from(
select tab1.*, tab2.codigo||' - '||tab2.descripcion as concepto, tab3.nombre_apellido,
per.id_anhos, per.id_meses

from no_certi_retefuente tab1

left join no_concep_nomina tab2 ON tab2.id_concep_nomina = tab1.id_concep_nomina
left join no_datos_funcionario_v tab3 on tab3.id_tipo_doc = tab1.id_tipo_doc and tab3.num_doc = tab1.num_doc
left join no_periodo per on per.id_periodo = tab1.id_periodo

)tab0

where tab0.id_anhos || lpad(tab0.id_meses, 2, '0')  <= (select periodo.id_anhos || lpad(periodo.id_meses, 2, '0') 
    from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro)
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_pago_cheque] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_doc, concepto';
        }

        //manejo de errores
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }

            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

'Total: ' || count(*) as num_doc,
SUM(valor_descuento)  as valor_descuento

FROM (  

select
tab0.*,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO

from(
select tab1.*, tab2.codigo||' - '||tab2.descripcion as concepto, tab3.nombre_apellido,
per.id_anhos, per.id_meses

from no_certi_retefuente tab1

left join no_concep_nomina tab2 ON tab2.id_concep_nomina = tab1.id_concep_nomina
left join no_datos_funcionario_v tab3 on tab3.id_tipo_doc = tab1.id_tipo_doc and tab3.num_doc = tab1.num_doc
left join no_periodo per on per.id_periodo = tab1.id_periodo

)tab0

where tab0.id_anhos || lpad(tab0.id_meses, 2, '0')  <= (select periodo.id_anhos || lpad(periodo.id_meses, 2, '0') 
    from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro)
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
    
$sortBy

)
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);

            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
